jjb: lttng-ust: Add log4j2 to agents config
[lttng-ci.git] / scripts / lttng-ust / build.sh
index 7dd809a0ddbd896848edaf7b503b1b697fe24dea..8f667c59044117b9c997ed224755bd42e530326e 100755 (executable)
@@ -1,4 +1,4 @@
-#!/bin/bash -exu
+#!/bin/bash
 #
 # Copyright (C) 2015 Jonathan Rajotte-Julien <jonathan.rajotte-julien@efficios.com>
 #               2016-2019 Michael Jeanson <mjeanson@efficios.com>
@@ -16,6 +16,8 @@
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
+set -exu
+
 # Version compare functions
 vercomp () {
     set +u
@@ -69,17 +71,35 @@ verne() {
     [ "$res" -ne "0" ]
 }
 
-# Required parameters
+failed_configure() {
+    # Assume we are in the configured build directory
+    echo "#################### BEGIN config.log ####################"
+    cat config.log
+    echo "#################### END config.log ####################"
+
+    # End the build with failure
+    exit 1
+}
+
+# Required variables
+WORKSPACE=${WORKSPACE:-}
+
 arch=${arch:-}
 conf=${conf:-}
 build=${build:-}
 cc=${cc:-}
 
+# Controls if the tests are run
+LTTNG_UST_RUN_TESTS="${LTTNG_UST_RUN_TESTS:=yes}"
 
 DEPS_INC="$WORKSPACE/deps/build/include"
 DEPS_LIB="$WORKSPACE/deps/build/lib"
+DEPS_PKGCONFIG="$DEPS_LIB/pkgconfig"
+#DEPS_BIN="$WORKSPACE/deps/build/bin"
+#DEPS_JAVA="$WORKSPACE/deps/build/share/java"
 
 export LD_LIBRARY_PATH="$DEPS_LIB:${LD_LIBRARY_PATH:-}"
+export PKG_CONFIG_PATH="$DEPS_PKGCONFIG"
 export CPPFLAGS="-I$DEPS_INC"
 export LDFLAGS="-L$DEPS_LIB"
 
@@ -158,15 +178,32 @@ fi
 
 # Set platform variables
 case "$arch" in
+freebsd)
+    export MAKE=gmake
+    export TAR=tar
+    export NPROC="getconf _NPROCESSORS_ONLN"
+    export CPPFLAGS="-I/usr/local/include $CPPFLAGS"
+    export LDFLAGS="-L/usr/local/lib $LDFLAGS"
+    export PYTHON="python3"
+    export PYTHON_CONFIG="python3-config"
+    export CLASSPATH='/usr/local/share/java/classes/*'
+    export JAVA_HOME='/usr/local/openjdk11'
+    ;;
+
 *)
     export MAKE=make
     export TAR=tar
     export NPROC=nproc
     export PYTHON="python3"
     export PYTHON_CONFIG="python3-config"
+    export CLASSPATH='/usr/share/java/log4j-api.jar:/usr/share/java/log4j-core.jar:/usr/share/java/log4j-1.2.jar'
     ;;
 esac
 
+# Print build env details
+print_os || true
+print_tooling || true
+
 # Enter the source directory
 cd "$SRCDIR"
 
@@ -175,23 +212,30 @@ cd "$SRCDIR"
 
 # Get source version from configure script
 eval "$(grep '^PACKAGE_VERSION=' ./configure)"
+PACKAGE_VERSION=${PACKAGE_VERSION//\-pre*/}
 
 # Set configure options and environment variables for each build
 # configuration.
 CONF_OPTS=("--prefix=$PREFIX")
 case "$conf" in
 static)
-    # Unsupported! liblttng-ust can't pull in it's static (.a) dependencies.
     echo "Static lib only configuration"
 
     CONF_OPTS+=("--enable-static" "--disable-shared")
+
+    # Unsupported! liblttng-ust can't pull in it's static (.a) dependencies.
+    exit 1
     ;;
 
 agents)
     echo "Java and Python agents configuration"
 
-    export CLASSPATH="/usr/share/java/log4j-1.2.jar"
     CONF_OPTS+=("--enable-java-agent-all" "--enable-jni-interface" "--enable-python-agent")
+
+    # Explicitly add '--enable-java-agent-log4j2', it's not part of '-all' in stable 2.12/2.13
+    if verlt "$PACKAGE_VERSION" "2.14"; then
+           CONF_OPTS+=("--enable-java-agent-log4j2")
+    fi
     ;;
 
 debug-rcu)
@@ -220,7 +264,7 @@ oot)
     builddir=$(mktemp -d)
     cd "$builddir"
 
-    "$SRCDIR/configure" "${CONF_OPTS[@]}"
+    "$SRCDIR/configure" "${CONF_OPTS[@]}" || failed_configure
     ;;
 
 dist)
@@ -228,7 +272,7 @@ dist)
 
     # Run configure and generate the tar file
     # in the source directory
-    ./configure
+    ./configure || failed_configure
     $MAKE dist
 
     # Create and enter a temporary build directory
@@ -240,7 +284,7 @@ dist)
     $TAR xvf "$SRCDIR"/*.tar.* --strip 1
 
     # Build in extracted source tree
-    ./configure "${CONF_OPTS[@]}"
+    ./configure "${CONF_OPTS[@]}" || failed_configure
     ;;
 
 oot-dist)
@@ -251,7 +295,7 @@ oot-dist)
     cd "$builddir"
 
     # Run configure out of tree and generate the tar file
-    "$SRCDIR/configure"
+    "$SRCDIR/configure" || failed_configure
     $MAKE dist
 
     dist_srcdir="$(mktemp -d)"
@@ -267,12 +311,12 @@ oot-dist)
 
     # Run configure from the extracted distribution tar,
     # out of the source tree
-    "$dist_srcdir/configure" "${CONF_OPTS[@]}"
+    "$dist_srcdir/configure" "${CONF_OPTS[@]}" || failed_configure
     ;;
 
 *)
     echo "Standard in-tree build"
-    ./configure "${CONF_OPTS[@]}"
+    ./configure "${CONF_OPTS[@]}" || failed_configure
     ;;
 esac
 
@@ -285,25 +329,32 @@ $MAKE -j "$($NPROC)" V=1
 $MAKE install DESTDIR="$WORKSPACE"
 
 # Run tests, don't fail now, we want to run the archiving steps
-set +e
-$MAKE --keep-going check
-ret=$?
-set -e
-
-# Copy tap logs for the jenkins tap parser before cleaning the build dir
-rsync -a --exclude 'test-suite.log' --include '*/' --include '*.log' --exclude='*' tests/ "$WORKSPACE/tap"
+failed_tests=0
+if [ "$LTTNG_UST_RUN_TESTS" = "yes" ]; then
+    $MAKE --keep-going check || failed_tests=1
+
+    # Copy tap logs for the jenkins tap parser before cleaning the build dir
+    rsync -a --exclude 'test-suite.log' --include '*/' --include '*.log' --exclude='*' tests/ "$WORKSPACE/tap"
+
+    # The test suite prior to 2.8 did not produce TAP logs
+    if verlt "$PACKAGE_VERSION" "2.8"; then
+        mkdir -p "$WORKSPACE/tap/no-log"
+        echo "1..1" > "$WORKSPACE/tap/no-log/tests.log"
+        echo "ok 1 - Test suite doesn't support logging" >> "$WORKSPACE/tap/no-log/tests.log"
+    fi
+fi
 
 # Clean the build directory
 $MAKE clean
 
 # Cleanup rpath in executables and shared libraries
-find "$WORKSPACE/$PREFIX/bin" -type f -perm -0500 -exec chrpath --delete {} \;
+#find "$WORKSPACE/$PREFIX/bin" -type f -perm -0500 -exec chrpath --delete {} \;
 find "$WORKSPACE/$PREFIX/lib" -name "*.so" -exec chrpath --delete {} \;
 
 # Remove libtool .la files
 find "$WORKSPACE/$PREFIX/lib" -name "*.la" -exec rm -f {} \;
 
-# Exit with the return code of the test suite
-exit $ret
+# Exit with failure if any of the tests failed
+exit $failed_tests
 
 # EOF
This page took 0.024978 seconds and 4 git commands to generate.